function CStrct = ConstrCurvStruct(Type, ZSpdMode, trafo, HSC,...
                                   Poff, Aoff, Uoff, Doff, P0, P1, A0, ...
                                   A1, U0, U1, Cprim, delta, evec, theta,...
                                   pitch, CoeffP5, FeedRate)
% Construct a struct for the curves.
%
% Type      : Type of curve
% ZSpdMode  : Zero speed mode
% trafo     : Flag for the trafo directive
% HSC       : High speed cutting (true : on, false : off)
% Poff      : Offset on the position {X, Y, Z}
% Aoff      : Offset on the angle {A, B, C}
% Uoff      : Offset on the sub-axis {U, V, W}
% Doff      : Offset for the diameter of the tool
% P0        : vector of the position at starting time
% P1        : vector of the position at ending time
% A0        : Vector of the orientation angles at starting time
% A1        : Vector of the orientation angles at ending time
% U0        : Vector of for the secondary axes at starting time
% U1        : Vector of for the secondary axes at ending time
% Cprim     : Corrected center for the circle
% delta     : Difference between the radii
% evec      : Unit vector in the linear direction for the helix
% theta     : Rotation angle of the helix
% pitch     : Linear step for the helix
% CoeffP5   : Coefficient of the 5th order polynom
% Feedrate  : Feedrate of the spindle
%
% CStrct    : The resulting structure

% ctxType = coder.OutputType('InitFeedoptPlan');
 
CStrct = struct('Type', Type, ...
                'zspdmode', ZSpdMode, ...
                'TRAFO', trafo, ...
                'HSC', HSC, ...
                'Poff', Poff, ...
                'Aoff', Aoff, ...
                'Uoff', Uoff, ...
                'Doff', Doff, ...
                'P0', P0, ...
                'P1', P1, ...
                'A0', A0,...
                'A1', A1,...
                'U0', U0,...
                'U1', U1,...
				'CorrectedHelixCenter', Cprim, ...
                'delta', delta, ...
                'evec', evec,...
                'theta', theta,...
                'pitch', pitch,...
                'CoeffP5', CoeffP5,...
                'sp_index', int32(1),...
                'FeedRate', FeedRate,...
                'SpindleSpeed', 0,...
                'MaxConstantFeedRate', 0,...
                'i_begin_sp', int32(0),...
                'i_end_sp', int32(0),...
                'gcode_source_line', int32(0),...
                'UseConstJerk', false,...
                'ConstJerk', 0,...
                'ConstJerkMaxIterations', int32(0),...
                'Coeff', zeros(0, 1),...
                'a_param', 1,...
                'b_param', 0,...
                'sp', struct('CoeffX', 0,...
                    'CoeffY', 0,...
                    'CoeffZ', 0,...
                    'CoeffB', 0,...
                    'CoeffC', 0,...
                    'Bl', struct(...
                        'ncoeff', int32(0),...
                        'breakpoints', zeros(1, 0),...
                        'handle', uint64(0),...
                        'degree', int32(0)),...
                    'knots', 0,...
                    'Ltot', 0,...
                    'Lk', 0));
         
if ~coder.target('matlab')
coder.cstructname(CStrct, 'CurvStruct');
coder.cstructname(CStrct.sp, 'SplineStruct');
coder.cstructname(CStrct.sp.Bl, 'SplineBase');

coder.varsize('CStrct.sp.Bl.breakpoints', [1, Inf], [0, 1]);

coder.varsize('CStrct.Coeff', [Inf, 1], [1, 0]);
coder.varsize('CStrct.sp.CoeffX', [1, Inf], [0, 1]);
coder.varsize('CStrct.sp.CoeffY', [1, Inf], [0, 1]);
coder.varsize('CStrct.sp.CoeffZ', [1, Inf], [0, 1]);
coder.varsize('CStrct.sp.knots',  [1, Inf], [0, 1]);
coder.varsize('CStrct.sp.Lk',     [1, Inf], [0, 1]);

coder.varsize('CStrct.CoeffP5', [3, 6], [0, 0]);
end
